<div class="taxonomy-table">
    <div class="input-group-append" style="min-width:22.5%;">
        <mat-form-field>
          <mat-label>Select lowest rank to be displayed</mat-label>
          <mat-select [(ngModel)]="this.maxRankSelection" (selectionChange)="lastRankSelectionChange()">
            <mat-option *ngFor="let rank of allRanks" [value]="rank">{{rank}}</mat-option>
          </mat-select>
        </mat-form-field>
      </div>
    <table mat-table style="width: 90%; overflow-y: auto; height: 100%" [dataSource]="tableDataSource" multiTemplateDataRows matSort (matSortChange)="sortTableData($event)">
        <!-- iterate over tableColumns (needed to be able to select which ranks get displayed + accounts for quantifications) -->
        @for (column of tableColumns; track column) {
          <!-- RANKS -->
          <ng-container [matColumnDef]="column">
            <ng-container *ngIf="tableColumns.indexOf(column) < tableColumns.indexOf(maxRankSelection) + 1 ? true : false">
              <th mat-header-cell mat-sort-header *matHeaderCellDef> {{column | titlecase}}</th>
              <td mat-cell *matCellDef="let element"> {{element[column]}}</td>
            </ng-container>
            <!-- QUANTIFICATIONS -->
            <ng-container *ngIf="tableColumns.indexOf(column) > tableColumns.indexOf(maxRankSelection) && column != 'checkbox' ? true : false">
              <th mat-header-cell mat-sort-header *matHeaderCellDef> Quantification {{column}}</th>
              <td mat-cell *matCellDef="let element"> {{element.quantifications[expIds.indexOf(column)]}}</td>
            </ng-container>
            <!-- CHECKBOXES -->
            <ng-container *ngIf="column == 'checkbox'">
                <th mat-header-cell *matHeaderCellDef>
                  <div style="display:flex;flex-direction: column;">
                    <div style="display:flex;justify-content: center;gap: 2px;">
                      <button class="btn btn-outline-secondary protein-table-visibility-button" matTooltip="Disable selected entries"
                        (click)="disableSelectedTableEntries()"><mat-icon style="transform:scale(0.7) translate(-0.7em,-0.7em)">visibility_off</mat-icon></button>
                      <button class="btn btn-outline-secondary protein-table-visibility-button" matTooltip="Enable selected entries"
                        (click)="enableSelectedTableEntries()"><mat-icon style="transform:scale(0.7) translate(-0.7em,-0.7em)">visibility</mat-icon></button>
                    </div>
                    <mat-checkbox [(ngModel)]="selectedAll" (change)="selectAllTableEntries()"></mat-checkbox>
                  </div>
                </th>
                <td mat-cell *matCellDef="let row">
                  <mat-checkbox [(ngModel)]="row.isSelected"></mat-checkbox>
                </td>
            </ng-container>
          </ng-container>
        }
    
        <tr mat-header-row *matHeaderRowDef="tableColumns; sticky: true"></tr>
        <tr mat-row *matRowDef="let row; columns: tableColumns;" (click)="clickRow(row)" class="taxonomy-row" [ngClass]="{
          'taxonomy-node-highlighted': isHighlightedRow(row),
          'taxonomy-disabled-row': !row.isDisplayed
        }"></tr>
      </table>
      <div style="display:flex; flex-direction: row; justify-content: space-between; width: 100%; align-items: center;">
        <mat-paginator #paginator style="background: none;" [pageSizeOptions]="[5,10,25,100]" [pageSize]="5" showFirstLastButtons></mat-paginator>
      </div>
</div>
